﻿
'Program Name:              Assignment 5
'Student Name:              Evan Lyons
'My submission of this program indicates that I have neither recieved nor
'given substantial assistance in writing this program.

Public Class Calculate
    'global variables for accumulator, counter, and sum of number of times letter is used in a word
    Dim intCounter As Integer = 0
    Dim intLetterSum As Integer = 0
    Dim intLetterTimes As Integer


    Private Sub btnRecord_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRecord.Click

        btnCalculate.Visible = True 'Makes Calculate visible when record is clicked
        txtName.ReadOnly = True 'Makes Name in text readonly when button it clicked


        'doesn't allow blank number
        If mtbNumber.Text = "" Then
            btnCalculate.Visible = False
            MsgBox("Can't leave number blank")
            mtbNumber.Clear()
            mtbNumber.Focus()
        End If

        'Input validation requiring comma for name
        If Not txtName.Text.Contains(",") Then
            btnCalculate.Visible = False
            MsgBox("Improper Name Entry")
            intCounter = intCounter - 1
            txtName.ReadOnly = False
            txtName.Clear()
            txtName.Focus()
        End If


        'variables for inputs

        Dim strLetterOutput As String = mtbLetter.Text
        Dim intNumLettersRecorded As Integer =CInt(mtbNumber.Text)
        Dim dblPointTotal As Double = CalculatePoints(strLetterOutput, intNumLettersRecorded) 'Use return from function


        If Not mtbLetter.Text = "" Then 'Input validation for blank letters
            intLetterSum += CInt(dblPointTotal) 'Sum each words letter value
            intLetterTimes += intNumLettersRecorded 'Sum the times a letter has been used in a word
        Else
            MsgBox("Must enter a letter")
            intCounter = intCounter - 1 'keeps counter from incrementing if letter isn't entered
        End If


        'clear inputs and restore focus
        mtbLetter.Clear()
        mtbNumber.Clear()
        mtbLetter.Focus()



    End Sub


    'Function to find letter point values

    Function CalculatePoints(ByVal LetterOutput As String, ByVal NumLetters As Integer) As Integer
        Dim intLetterPointTotal As Integer 'Keep track of points derived from letter and count usage of each letter
            Select Case LetterOutput
                Case "V", "v"
                    intLetterPointTotal = 4
                    intCounter += 1
                Case "W", "w"
                    intLetterPointTotal = 5
                    intCounter += 1
                Case "X", "x"
                    intLetterPointTotal = 3
                    intCounter += 1
                Case "Y", "y"
                    intLetterPointTotal = 7
                    intCounter += 1
                Case "Z", "z"
                    intLetterPointTotal = 1
                    intCounter += 1
                Case Else
                    intLetterPointTotal = 0
                    intCounter += 1
            End Select
            Return intLetterPointTotal * NumLetters 'find number of points for letters in a word
    End Function


    Private Sub btnCalculate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCalculate.Click

            'First and last name variables
            Dim strLastName As String = txtName.Text
            Dim strFirstName As String = txtName.Text
            ArrangeName(strFirstName, strLastName) 'passes new values to variables
            txtOutput.Text = strFirstName & " " & strLastName & vbNewLine & vbNewLine & " Number of letters recorded: " & intCounter & vbNewLine & vbNewLine &
                " Current Total Average: " & FormatNumber((intLetterSum / intLetterTimes), 1) 'calculate the average


    End Sub

    Sub ArrangeName(ByRef FirstName As String, ByRef LastName As String)
        'variables to find index values for first and last names
        Dim intCommaIndex As Integer = txtName.Text.IndexOf(",")
        Dim intSpace As Integer = txtName.Text.IndexOf(" ")
        'new values to pass to variables in calculate button
        FirstName = txtName.Text.Substring(intSpace)
        LastName = txtName.Text.Substring(0, intCommaIndex)


    End Sub


    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Me.Close()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        txtName.Clear()
        txtOutput.Clear()
        mtbLetter.Clear()
        mtbNumber.Clear()
        intCounter = 0
        intLetterSum = 0
        intLetterTimes = 0
        btnCalculate.Visible = False
        txtName.ReadOnly = False
        txtName.Focus()
    End Sub
End Class
